#include <vector>
#include <string.h>
#include <iostream>

#include "rapidxml-1.13/rapidxml.hpp"
#include "rapidxml-1.13/rapidxml_utils.hpp"

#ifndef namespace_rapidxml
#define namespace_rapidxml
using namespace rapidxml;
#endif

#ifndef namespace_std
#define namespace_std
using namespace std;
#endif


#ifndef xml2latex_hpp
#define xml2latex_hpp

class MyRapid
{
public :
    xml_document<> * XML;
    vector<char> * XMLvect;
    MyRapid(string file,string extension);
    ~MyRapid();
    bool read_xml_file(string file, string extension);
};

class Xnode
{
public:
    xml_node<> *Org;
    vector<Xnode*> XList;
    Xnode(xml_node<> *org);
    virtual ~Xnode();
    virtual void Xml2LaTeX(ostream & file,int kind);
};

class TYPE:public Xnode
{
public:
    string Name;
    TYPE(string name);
    virtual void Xml2LaTeX(ostream & file,int kind);
};

class _CATALOG: public Xnode
{
public:
    _CATALOG(xml_node<> *org);
    TYPE* DATA[3];
    virtual void Xml2LaTeX(ostream & file,int kind);
};

class _PLANT: public Xnode
{
public:
    _PLANT(xml_node<> *org);
};

class _BOOK: public Xnode
{
public:
    _BOOK(xml_node<> *org);
};

class _FOOD: public Xnode
{
public:
    _FOOD(xml_node<> *org);
};

class _DATE: public Xnode
{
    string D,M,Y;
public:
    _DATE(xml_node<> *org);
    virtual void Xml2LaTeX(ostream & file,int kind);
};

class Xml2Latex
{
public:
    MyRapid * DataXML;
    _CATALOG * Catalog;
    Xml2Latex(string FileXML);
    ~Xml2Latex();
    void ADDpreamble(ostream & file);
    void CreateText();
};

#endif
